<?php
/***********************************************************************

  Copyright (C) 2002, 2003, 2004  Rickard Andersson (rickard@punbb.org)

  This file is part of PunBB.

  PunBB is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published
  by the Free Software Foundation; either version 2 of the License,
  or (at your option) any later version.

  PunBB is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
  MA  02111-1307  USA

************************************************************************/


$pun_root = './';
require $pun_root.'include/common.php';


// This particular function doesn't require forum-based moderator access. It can be used
// by all moderators and admins.
if (isset($_GET['get_host']))
{
	$get_host = intval($_GET['get_host']);
	if (empty($get_host))
		message($lang_common['Bad request']);

	if ($cur_user['status'] < PUN_MOD)
		message($lang_common['No permission']);

	$result = $db->query('SELECT poster_ip FROM '.$db->prefix.'posts WHERE id='.$get_host) or error('Unable to fetch post IP address', __FILE__, __LINE__, $db->error());
	if (!$db->num_rows($result))
		message($lang_common['Bad request']);

	$ip = $db->result($result, 0);

	message('The IP address is: '.$ip.'<br>The host name is: '.gethostbyaddr($ip).'<br><br><a href="admin_users.php?show_users='.$ip.'">Show more users for this IP</a>');
}


// All other functions require moderator/admin access
$fid = intval($_GET['fid']);
if (empty($fid))
	message($lang_common['Bad request']);

if (!is_admmod($fid, $foo, $foo))
	message($lang_common['No permission']);


// Load the misc.php language file
require $pun_root.'lang/'.$language.'/'.$language.'_misc.php';


// All other topic moderation features require a topic id in GET
if (isset($_GET['tid']))
{
	$tid = intval($_GET['tid']);
	if (empty($tid) || $tid < 0)
		message($lang_common['Bad request']);

	// Fetch some info from the topic
	$result = $db->query('SELECT subject, num_replies, forum_id FROM '.$db->prefix.'topics WHERE id='.$tid.' AND moved_to IS NULL') or error('Unable to fetch topic info', __FILE__, __LINE__, $db->error());
	if (!$db->num_rows($result))
		message($lang_common['Bad request']);

	list($subject, $num_replies, $forum_id) = $db->fetch_row($result);

	// Make sure the forum ID supplied through GET matches the topic ID
	if ($forum_id != $fid)
		message($lang_common['Bad request']);


	// Delete one or more posts
	if (isset($_POST['delete_posts']) || isset($_POST['delete_posts_comply']))
	{
		$posts = $_POST['posts'];
		if (empty($posts))
			message($lang_misc['No posts selected']);

		if (isset($_POST['delete_posts_comply']))
		{
			confirm_referer('moderate.php');

			// Delete the posts (start transaction)
			$db->query('DELETE FROM '.$db->prefix.'posts WHERE id IN('.$posts.')', PUN_TRANS_START) or error('Unable to delete posts', __FILE__, __LINE__, $db->error());

			require $pun_root.'include/search_idx.php';
			strip_search_index($posts);

			// Get last_post, last_post_id, and last_poster for the topic after deletion
			$result = $db->query('SELECT id, poster, posted FROM '.$db->prefix.'posts WHERE topic_id='.$tid.' ORDER BY id DESC LIMIT 1') or error('Unable to fetch post info', __FILE__, __LINE__, $db->error());
			$last_post = $db->fetch_assoc($result);

			// How many posts did we just delete?
			$num_posts_deleted = substr_count($posts, ',') + 1;

			// Update the topic
			$db->query('UPDATE '.$db->prefix.'topics SET last_post='.$last_post['posted'].', last_post_id='.$last_post['id'].', last_poster=\''.addslashes($last_post['poster']).'\', num_replies=num_replies-'.$num_posts_deleted.' WHERE id='.$tid) or error('Unable to update topic', __FILE__, __LINE__, $db->error());

			update_forum($fid, PUN_TRANS_END);	// (end transaction)

			redirect('viewtopic.php?id='.$tid, $lang_misc['Delete posts redirect']);
		}


		$page_title = pun_htmlspecialchars($pun_config['o_board_title']).' / '.$lang_misc['Moderate'];
		require $pun_root.'header.php';

?>
<table class="punspacer" cellspacing="1" cellpadding="4"><tr><td>&nbsp;</td></tr></table>

<form method="post" action="moderate.php?fid=<?php echo $fid ?>&amp;tid=<?php echo $tid ?>">
	<input type="hidden" name="posts" value="<?php echo implode(',', array_keys($posts)) ?>">
	<table class="punmain" cellspacing="1" cellpadding="4">
		<tr class="punhead">
			<td class="punhead"><?php echo $lang_misc['Delete posts'] ?></td>
		</tr>
		<tr>
			<td class="puncon2">
				<br>&nbsp;<?php echo $lang_misc['Delete posts comply'] ?><br><br>
				&nbsp;<input type="submit" name="delete_posts_comply" value="<?php echo $lang_misc['Delete'] ?>">&nbsp;&nbsp;&nbsp;<a href="javascript:history.go(-1)"><?php echo $lang_common['Go back'] ?></a><br><br>
			</td>
		</tr>
	</table>
</form>

<table class="punspacer" cellspacing="1" cellpadding="4"><tr><td>&nbsp;</td></tr></table>
<?php

		require $pun_root.'footer.php';
	}


	// Show the delete multiple posts view
	else
	{
		// Load the viewtopic.php language file
		require $pun_root.'lang/'.$language.'/'.$language.'_topic.php';

		// Used to disable the Move and Delete buttons if there are no replies to this topic
		$button_status = ($num_replies == 0) ? ' disabled' : '';


		// Fetch the forum name
		$result = $db->query('SELECT forum_name FROM '.$db->prefix.'forums WHERE id='.$fid) or error('Unable to fetch forum info', __FILE__, __LINE__, $db->error());
		$forum_name = $db->result($result, 0);


		// Determine the post offset (based on $_GET['p'])
		$num_pages = ceil(($num_replies + 1) / $cur_user['disp_posts']);

		$p = (!isset($_GET['p']) || $_GET['p'] <= 1 || $_GET['p'] > $num_pages) ? 1 : $_GET['p'];
		$start_from = $cur_user['disp_posts'] * ($p - 1);

		$pages = paginate($num_pages, $p, 'moderate.php?fid='.$fid.'&amp;tid='.$tid);


		if ($pun_config['o_censoring'] == '1')
			$subject = censor_words($subject);

		$page_title = pun_htmlspecialchars($pun_config['o_board_title']).' / '.$subject;
		require $pun_root.'header.php';

?>
<table class="punspacer" cellspacing="1" cellpadding="4">
	<tr>
		<td><b><a href="index.php"><?php echo pun_htmlspecialchars($pun_config['o_board_title']) ?></a> / <a href="viewforum.php?id=<?php echo $fid ?>"><?php echo pun_htmlspecialchars($forum_name) ?></a> / <?php echo pun_htmlspecialchars($subject) ?></b></td>
	</tr>
</table>

<table class="punmain" cellspacing="1" cellpadding="4">
	<tr class="punhead">
		<td class="punhead" style="width: 185px; white-space: nowrap"><?php echo $lang_common['Author'] ?></td>
		<td style="white-space: nowrap">
			<table class="punplain" cellspacing="0" cellpadding="0">
				<tr>
					<td class="punhead" style="width: 20%"><?php echo $lang_common['Message'] ?></td>
					<td><?php echo $lang_common['Pages'].': '.$pages ?></td>
				</tr>
			</table>
		</td>
		<td class="punheadcent" style="width: 7%; white-space: nowrap"><?php echo $lang_misc['Select'] ?></td>
	</tr>
</table>

<form method="post" action="moderate.php?fid=<?php echo $fid ?>&amp;tid=<?php echo $tid ?>">
<?php


		require $pun_root.'include/parser.php';

		// Used for switching background color in posts
		$bg_switch = true;


		// Retrieve the first post in the topic (there shouldn't be a move/delete checkbox for this post)
		$result = $db->query('SELECT id FROM '.$db->prefix.'posts WHERE topic_id='.$tid.' ORDER BY id LIMIT 1') or error('Unable to fetch post info', __FILE__, __LINE__, $db->error());
		$first_post = $db->result($result, 0);


		// Retrieve the posts (and their respective poster)
		$result = $db->query('SELECT u.title, u.num_posts, u.status, p.id, p.poster, p.poster_id, p.poster_ip, p.poster_email, p.message, p.smilies, p.posted, p.edited, p.edited_by FROM '.$db->prefix.'posts AS p INNER JOIN '.$db->prefix.'users AS u ON u.id=p.poster_id WHERE p.topic_id='.$tid.' ORDER BY p.id LIMIT '.$start_from.','.$cur_user['disp_posts']) or error('Unable to fetch post info', __FILE__, __LINE__, $db->error());

		while ($cur_post = $db->fetch_assoc($result))
		{
			// If the poster is a registered user.
			if ($cur_post['poster_id'] > 1)
			{
				$registered = date($pun_config['o_date_format'], $cur_post['registered']);

				$info = '<span class="punheadline"><a href="profile.php?id='.$cur_post['poster_id'].'">'.pun_htmlspecialchars($cur_post['poster']).'</a></span>';

				// get_title() requires that an element 'username' be present in the array
				$cur_post['username'] = $cur_post['poster'];
				$user_title = get_title($cur_post);

				if ($pun_config['o_censoring'] == '1')
					$user_title = censor_words($user_title);

				$info .= '<br>'."\n\t\t\t\t\t\t\t\t".$user_title.'<br><br>';
			}
			// If the poster is a guest (or a user that has been deleted)
			else
				$info = '<span class="punheadline">'.pun_htmlspecialchars($cur_post['poster']).'</span><br>'."\n\t\t\t\t\t\t\t\t".$lang_topic['Guest'].'<br><br>';


			// Switch the background color for every message.
			$bg_switch = ($bg_switch) ? $bg_switch = false : $bg_switch = true;

			// Perform the main parsing of the message (BBCode, smilies, censor words etc)
			$cur_post['message'] = parse_message($cur_post['message'], $cur_post['smilies']);

?>
	<table class="punmain" cellspacing="1" cellpadding="4">
		<tr class="<?php echo ($bg_switch) ? 'puncon1' : 'puncon2'; ?>">
			<td class="puntop" style="width: 185px">
				<table class="punplain" cellspacing="0" cellpadding="0">
					<tr>
						<td>
							<div style="width: 185px">
								<?php echo $info."\n" ?>
							</div>
						</td>
					</tr>
				</table>
			</td>
			<td class="puntop">
				<table class="punplain" cellspacing="0" cellpadding="0">
					<tr>
						<td>
							<span class="puntext"><?php echo $cur_post['message'] ?></span><?php echo (isset($signature)) ? '<span class="punsignature">'.$signature.'</span>'."\n" : '<br><br>'."\n"; ?>
						</td>
					</tr>
				</table>
			</td>
			<td class="puncent" style="width: 7%"><?php echo ($cur_post['id'] != $first_post) ? '<input type="checkbox" name="posts['.$cur_post['id'].']" value="1">' : '--' ?></td>
		</tr>
	</table>

<?php

		}

?>
	<table class="punspacer" cellspacing="1" cellpadding="4">
		<tr>
			<td><?php echo $lang_common['Pages'].': '.$pages ?></td>
			<td class="punright">
				<input type="submit" name="delete_posts" value="<?php echo $lang_misc['Delete'] ?>"<?php echo $button_status ?>>
			</td>
		</tr>
	</table>
</form>
<?php

		require $pun_root.'footer.php';
	}
}


// Move one or more topics
if (isset($_REQUEST['move_topics']) || isset($_POST['move_topics_to']))
{
	if (isset($_POST['move_topics_to']))
	{
		confirm_referer('moderate.php');

		$topics = explode(',', $_POST['topics']);
		$move_to_forum = intval($_POST['move_to_forum']);
		if (empty($topics) || empty($move_to_forum))
			message($lang_common['Bad request']);

		// Delete any redirect topics if there are any (only if we moved/copied the topic back to where it where it was once moved from) (start transaction)
		$db->query('DELETE FROM '.$db->prefix.'topics WHERE forum_id='.$move_to_forum.' AND moved_to IN('.implode(',',$topics).')', PUN_TRANS_START) or error('Unable to delete redirect topics', __FILE__, __LINE__, $db->error());

		// Move the topic(s)
		$db->query('UPDATE '.$db->prefix.'topics SET forum_id='.$move_to_forum.' WHERE id IN('.implode(',',$topics).')') or error('Unable to move topics', __FILE__, __LINE__, $db->error());

		// Should we create redirect topics?
		if ($_POST['with_redirect'] == '1')
		{
			while (list(, $cur_topic) = @each($topics))
			{
				// Fetch info for the redirect topic
				$result = $db->query('SELECT poster, subject, posted, last_post FROM '.$db->prefix.'topics WHERE id='.$cur_topic) or error('Unable to fetch topic info', __FILE__, __LINE__, $db->error());
				$moved_to = $db->fetch_assoc($result);

				// Create the redirect topic
				$db->query('INSERT INTO '.$db->prefix.'topics (poster, subject, posted, last_post, moved_to, forum_id) VALUES(\''.addslashes($moved_to['poster']).'\', \''.addslashes($moved_to['subject']).'\', '.$moved_to['posted'].', '.$moved_to['last_post'].', '.$cur_topic.', '.$fid.')') or error('Unable to create redirect topic', __FILE__, __LINE__, $db->error());
			}
		}

		update_forum($fid);								// Update the forum FROM which the topic was moved
		update_forum($move_to_forum, PUN_TRANS_END);	// Update the forum TO which the topic was moved (end transaction)

		$redirect_msg = (count($topics) > 1) ? $lang_misc['Move topics redirect'] : $lang_misc['Move topic redirect'];
		redirect('viewforum.php?id='.$move_to_forum, $redirect_msg);
	}

	if (isset($_POST['move_topics']))
	{
		$topics = $_POST['topics'];
		if (empty($topics))
			message($lang_misc['No topics selected']);

		$topics = implode(',', array_keys($topics));
		$action = 'multi';
	}
	else
	{
		$topics = intval($_GET['move_topics']);
		if (empty($topics))
			message($lang_common['Bad request']);

		$action = 'single';
	}

	$page_title = pun_htmlspecialchars($pun_config['o_board_title']).' / Moderate';
	require $pun_root.'header.php';

?>
<table class="punspacer" cellspacing="1" cellpadding="4"><tr><td>&nbsp;</td></tr></table>

<form method="post" action="moderate.php?fid=<?php echo $fid ?>">
	<input type="hidden" name="topics" value="<?php echo $topics ?>">
	<table class="punmain" cellspacing="1" cellpadding="4">
		<tr class="punhead">
			<td class="punhead"><?php echo ($action == 'single') ? $lang_misc['Move topic'] : $lang_misc['Move topics'] ?></td>
		</tr>
		<tr>
			<td class="puncon2">
				<br>&nbsp;<?php echo $lang_misc['Move to'] ?>&nbsp;&nbsp;<select name="move_to_forum">
<?php

		$result = $db->query('SELECT c.id AS cid, c.cat_name, f.id AS fid, f.forum_name FROM '.$db->prefix.'categories AS c INNER JOIN '.$db->prefix.'forums AS f ON c.id=f.cat_id'.$extra.' ORDER BY c.disp_position, c.id, f.disp_position') or error('Unable to fetch category/forum list', __FILE__, __LINE__, $db->error());

		while ($cur_forum = $db->fetch_assoc($result))
		{
			if ($cur_forum['cid'] != $cur_category)	// A new category since last iteration?
			{
				if (!empty($cur_category))
					echo "\t\t\t\t\t".'</optgroup>'."\n";

				echo "\t\t\t\t\t".'<optgroup label="'.pun_htmlspecialchars($cur_forum['cat_name']).'">'."\n";
				$cur_category = $cur_forum['cid'];
			}

			if ($cur_forum['fid'] != $fid)
				echo "\t\t\t\t\t\t".'<option value="'.$cur_forum['fid'].'">'.pun_htmlspecialchars($cur_forum['forum_name']).'</option>'."\n";
		}

?>
					</optgroup>
				</select><br><br>
				<input type="checkbox" name="with_redirect" value="1"<?php if ($action == 'single') echo ' checked' ?>>&nbsp;<?php echo $lang_misc['Leave redirect'] ?><br><br>
				&nbsp;&nbsp;<input type="submit" name="move_topics_to" value="<?php echo $lang_misc['Move'] ?>"><br><br>
			</td>
		</tr>
	</table>
</form>

<table class="punspacer" cellspacing="1" cellpadding="4"><tr><td>&nbsp;</td></tr></table>
<?php

	require $pun_root.'footer.php';
}


// Delete one or more topics
if (isset($_REQUEST['delete_topics']) || isset($_POST['delete_topics_comply']))
{
	$topics = $_POST['topics'];
	if (empty($topics))
		message($lang_misc['No topics selected']);

	if (isset($_POST['delete_topics_comply']))
	{
		confirm_referer('moderate.php');

		require $pun_root.'include/search_idx.php';

		// Delete the topic and any redirect topics (start transaction)
		$db->query('DELETE FROM '.$db->prefix.'topics WHERE id IN('.$topics.') OR moved_to IN('.$topics.')', PUN_TRANS_START) or error('Unable to delete topic', __FILE__, __LINE__, $db->error());

		// Create a list of the post ID's in this topic and then strip the search index
		$result = $db->query('SELECT id FROM '.$db->prefix.'posts WHERE topic_id IN('.$topics.')') or error('Unable to fetch posts', __FILE__, __LINE__, $db->error());
		while ($row = $db->fetch_row($result))
			$post_ids .= ($post_ids != '') ? ','.$row[0] : $row[0];

		// We have to check that we actually have a list of post ID's since we could be deleting just a redirect topic
		if (isset($post_ids))
			strip_search_index($post_ids);

		// Delete posts
		$db->query('DELETE FROM '.$db->prefix.'posts WHERE topic_id IN('.$topics.')') or error('Unable to delete posts', __FILE__, __LINE__, $db->error());

		update_forum($fid, PUN_TRANS_END);	// (end transaction)

		redirect('viewforum.php?id='.$fid, $lang_misc['Delete topics redirect']);
	}


	$page_title = pun_htmlspecialchars($pun_config['o_board_title']).' / '.$lang_misc['Moderate'];
	require $pun_root.'header.php';

?>
<table class="punspacer" cellspacing="1" cellpadding="4"><tr><td>&nbsp;</td></tr></table>

<form method="post" action="moderate.php?fid=<?php echo $fid ?>">
	<input type="hidden" name="topics" value="<?php echo implode(',', array_keys($topics)) ?>">
	<table class="punmain" cellspacing="1" cellpadding="4">
		<tr class="punhead">
			<td class="punhead"><?php echo $lang_misc['Delete topics'] ?></td>
		</tr>
		<tr>
			<td class="puncon2">
				<br>&nbsp;<?php echo $lang_misc['Delete topics comply'] ?><br><br>
				&nbsp;<input type="submit" name="delete_topics_comply" value="<?php echo $lang_misc['Delete'] ?>">&nbsp;&nbsp;&nbsp;<a href="javascript:history.go(-1)"><?php echo $lang_common['Go back'] ?></a><br><br>
			</td>
		</tr>
	</table>
</form>

<table class="punspacer" cellspacing="1" cellpadding="4"><tr><td>&nbsp;</td></tr></table>
<?php

	require $pun_root.'footer.php';
}


// Open or close one or more topics
else if (isset($_REQUEST['open']) || isset($_REQUEST['close']))
{
	$action = (isset($_REQUEST['open'])) ? 0 : 1;

	// There could be an array of topic ID's in $_POST
	if (isset($_POST['open']) || isset($_POST['close']))
	{
		confirm_referer('moderate.php');

		$topics = $_POST['topics'];
		if (empty($topics))
			message($lang_misc['No topics selected']);

		$db->query('UPDATE '.$db->prefix.'topics SET closed='.$action.' WHERE id IN('.implode(',', array_keys($topics)).')') or error('Unable to close topics', __FILE__, __LINE__, $db->error());

		$redirect_msg = ($action) ? $lang_misc['Close topics redirect'] : $lang_misc['Open topics redirect'];
		redirect('moderate.php?fid='.$fid, $redirect_msg);
	}
	// Or just one in $_GET
	else
	{
		confirm_referer('viewtopic.php');

		$topic_id = ($action) ? intval($_GET['close']) : intval($_GET['open']);
		if (empty($topic_id))
			message($lang_common['Bad request']);

		$db->query('UPDATE '.$db->prefix.'topics SET closed='.$action.' WHERE id='.$topic_id) or error('Unable to close topic', __FILE__, __LINE__, $db->error());

		$redirect_msg = ($action) ? $lang_misc['Close topic redirect'] : $lang_misc['Open topic redirect'];
		redirect('viewtopic.php?id='.$topic_id, $redirect_msg);
	}
}


// Stick a topic
else if (isset($_GET['stick']))
{
	confirm_referer('viewtopic.php');

	$stick = intval($_GET['stick']);
	if (empty($stick))
		message($lang_common['Bad request']);

	$db->query('UPDATE '.$db->prefix.'topics SET sticky=\'1\' WHERE id='.$stick) or error('Unable to stick topic', __FILE__, __LINE__, $db->error());

	redirect('viewtopic.php?id='.$stick, 'Topic sticked. Redirecting ...');
}


// Unstick a topic
else if (isset($_GET['unstick']))
{
	confirm_referer('viewtopic.php');

	$unstick = intval($_GET['unstick']);
	if (empty($unstick))
		message($lang_common['Bad request']);

	$db->query('UPDATE '.$db->prefix.'topics SET sticky=\'0\' WHERE id='.$unstick) or error('Unable to unstick topic', __FILE__, __LINE__, $db->error());

	redirect('viewtopic.php?id='.$unstick, 'Topic unsticked. Redirecting ...');
}


// Show the moderate forum view
else
{
	// Load the viewforum.php language file
	require $pun_root.'lang/'.$language.'/'.$language.'_forum.php';

	// Fetch some info from the forum
	$result = $db->query('SELECT forum_name, num_topics, closed, admmod_only FROM '.$db->prefix.'forums WHERE id='.$fid) or error('Unable to fetch forum info', __FILE__, __LINE__, $db->error());
	if (!$db->num_rows($result))
		message($lang_common['Bad request'], true);

	list($forum_name, $num_topics, $closed, $admmod_only) = $db->fetch_row($result);


	$page_title = pun_htmlspecialchars($pun_config['o_board_title']).' / '.pun_htmlspecialchars($forum_name);
	require $pun_root.'header.php';

?>
<table class="punspacer" cellspacing="1" cellpadding="4">
	<tr>
		<td><b><a href="index.php"><?php echo pun_htmlspecialchars($pun_config['o_board_title']) ?></a> / <?php echo pun_htmlspecialchars($forum_name) ?></b></td>
	</tr>
</table>

<form method="post" action="moderate.php?fid=<?php echo $fid ?>">
	<table class="punmain" cellspacing="1" cellpadding="4">
		<tr class="punhead">
			<td class="punhead" style="width: 24px">&nbsp;</td>
			<td class="punhead" style="white-space: nowrap"><?php echo $lang_common['Topic'] ?></td>
			<td class="punhead" style="width: 13%; white-space: nowrap"><?php echo $lang_common['Author'] ?></td>
			<td class="punheadcent" style="width: 6%; white-space: nowrap"><?php echo $lang_common['Replies'] ?></td>
			<td class="punheadcent" style="width: 6%; white-space: nowrap"><?php echo $lang_forum['Views'] ?></td>
			<td class="punhead" style="width: 24%; white-space: nowrap"><?php echo $lang_common['Last post'] ?></td>
			<td class="punheadcent" style="width: 7%; white-space: nowrap"><?php echo $lang_misc['Select'] ?></td>
		</tr>
<?php


	// Determine the topic offset (based on $_GET['p'])
	$num_pages = ceil($num_topics / $cur_user['disp_topics']);

	$p = (!isset($_GET['p']) || $_GET['p'] <= 1 || $_GET['p'] > $num_pages) ? 1 : $_GET['p'];
	$start_from = $cur_user['disp_topics'] * ($p - 1);


	// Select topics
	$result = $db->query('SELECT id, poster, subject, posted, last_post, last_post_id, last_poster, num_views, num_replies, closed, sticky, moved_to FROM '.$db->prefix.'topics WHERE forum_id='.$fid.' ORDER BY sticky DESC, last_post DESC LIMIT '.$start_from.', '.$cur_user['disp_topics']) or error('Unable to fetch topic list for forum', __FILE__, __LINE__, $db->error());


	// If there are topics in this forum.
	if ($db->num_rows($result))
	{
		$button_status = '';

		while ($cur_topic = $db->fetch_assoc($result))
		{
			if ($cur_topic['moved_to'] == null)
			{
				$last_post = '<a href="viewtopic.php?pid='.$cur_topic['last_post_id'].'#'.$cur_topic['last_post_id'].'">'.format_time($cur_topic['last_post']).'</a> '.$lang_common['by'].' '.pun_htmlspecialchars($cur_topic['last_poster']);
				$ghost_topic = false;
			}
			else
			{
				$last_post = '&nbsp;';
				$ghost_topic = true;
			}

			if ($pun_config['o_censoring'] == '1')
				$cur_topic['subject'] = censor_words($cur_topic['subject']);

			if ($cur_topic['moved_to'] != 0)
				$subject = $lang_forum['Moved'].': <a href="viewtopic.php?id='.$cur_topic['moved_to'].'">'.pun_htmlspecialchars($cur_topic['subject']).'</a>';
			else if ($cur_topic['closed'] == '0' && $closed == '0')
				$subject = '<a href="viewtopic.php?id='.$cur_topic['id'].'">'.pun_htmlspecialchars($cur_topic['subject']).'</a>';
			else
				$subject = '<a class="punclosed" href="viewtopic.php?id='.$cur_topic['id'].'">'.pun_htmlspecialchars($cur_topic['subject']).'</a>';

			if ($cur_topic['last_post'] > $cur_user['last_visit'] && !$ghost_topic)
			{
				if ($cur_user['show_img'] == '1')
					$icon = '<img src="img/'.$cur_user['style'].'_new.png" width="16" height="16" alt="">';
				else
					$icon = '<span class="puntext"><b>&#8226;</b></span>';

				$subject = '<b>'.$subject.'</b>';
				$subject_new_posts = '[&nbsp;<a href="viewtopic.php?id='.$cur_topic['id'].'&amp;action=new" title="'.$lang_common['New posts info'].'">'.$lang_common['New posts'].'</a>&nbsp;]';
			}
			else
			{
				$icon = '&nbsp;';
				$subject_new_posts = null;
			}

			// We won't display "the dot", but we add the spaces anyway
			if ($pun_config['o_show_dot'] == '1')
				$subject = '&nbsp;&nbsp;'.$subject;

			if ($cur_topic['sticky'] == '1')
				$subject = $lang_forum['Sticky'].': '.$subject;

			$num_pages_topic = ceil(($cur_topic['num_replies'] + 1) / $cur_user['disp_posts']);

			if ($num_pages_topic > 1)
			{
				$stop = ($num_pages_topic < 3) ? ($num_pages_topic + 1) : 4;

				$subject_multipage = '[';
				for ($current = 1; $current < $stop; ++$current)
					$subject_multipage .= '&nbsp;<a href="viewtopic.php?id='.$cur_topic['id'].'&amp;p='.$current.'">'.$current.'</a>';

				if ($num_pages_topic > 3)
					$subject_multipage .= '&nbsp;...&nbsp;<a href="viewtopic.php?id='.$cur_topic['id'].'&amp;p='.$num_pages_topic.'">'.$num_pages_topic.'</a>&nbsp;]';
				else
					$subject_multipage .= '&nbsp;]';
			}
			else
				$subject_multipage = null;

			// Should we show the "New posts" and/or the multipage links?
			if (!empty($subject_new_posts) || !empty($subject_multipage))
			{
				$subject .= '&nbsp; '.(!empty($subject_new_posts) ? $subject_new_posts : '');
				$subject .= !empty($subject_multipage) ? ' '.$subject_multipage : '';
			}

?>
		<tr class="puntopic">
			<td class="puncon1cent"><?php echo $icon ?></td>
			<td class="puncon2"><?php echo $subject ?></td>
			<td class="puncon1"><?php echo pun_htmlspecialchars($cur_topic['poster']) ?></td>
			<td class="puncon2cent"><?php echo (!$ghost_topic) ? $cur_topic['num_replies'] : '&nbsp;' ?></td>
			<td class="puncon1cent"><?php echo (!$ghost_topic) ? $cur_topic['num_views'] : '&nbsp;' ?></td>
			<td class="puncon2" style="white-space: nowrap"><?php echo $last_post ?></td>
			<td class="puncon1cent" style="white-space: nowrap"><input type="checkbox" name="topics[<?php echo $cur_topic['id'] ?>]" value="1"></td>
		</tr>
<?php

		}
	}
	else
	{
		$button_status = ' disabled';
		echo "\t\t".'<tr><td class="puncon1" colspan="7">'.$lang_forum['Empty forum'].'</td></tr>'."\n";
	}

?>
	</table>

	<table class="punspacer" cellspacing="1" cellpadding="4">
		<tr>
			<td><?php echo $lang_common['Pages'].': '.paginate($num_pages, $p, 'moderate.php?fid='.$fid) ?></td>
			<td class="punright">
				<input type="submit" name="move_topics" value="<?php echo $lang_misc['Move'] ?>"<?php echo $button_status ?>>&nbsp;&nbsp;<input type="submit" name="delete_topics" value="<?php echo $lang_misc['Delete'] ?>"<?php echo $button_status ?>>&nbsp;&nbsp;<input type="submit" name="open" value="<?php echo $lang_misc['Open'] ?>"<?php echo $button_status ?>>&nbsp;&nbsp;<input type="submit" name="close" value="<?php echo $lang_misc['Close'] ?>"<?php echo $button_status ?>>
			</td>
		</tr>
	</table>
</form>
<?php

	require $pun_root.'footer.php';
}
