<?php
/***********************************************************************

  Copyright (C) 2002, 2003, 2004  Rickard Andersson (rickard@punbb.org)

  This file is part of PunBB.

  PunBB is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published
  by the Free Software Foundation; either version 2 of the License,
  or (at your option) any later version.

  PunBB is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
  MA  02111-1307  USA

************************************************************************/


$pun_root = './';
require $pun_root.'include/common.php';


if ($cookie['is_guest'] && $pun_config['p_guests_read'] == '0')
	message($lang_common['Login required']);


if (!$cookie['is_guest'])
{
	$disp_topics = $cur_user['disp_topics'];
	$disp_posts = $cur_user['disp_posts'];
}
else
{
	$disp_topics = $pun_config['o_disp_topics_default'];
	$disp_posts = $pun_config['o_disp_posts_default'];
}

$id = intval($_GET['id']);
if (empty($id) || $id < 0)
	message($lang_common['Bad request']);

// Load the viewforum.php language file
require $pun_root.'lang/'.$language.'/'.$language.'_forum.php';

// Fetch some info from the forum
$result = $db->query('SELECT forum_name, moderators, num_topics, closed, admmod_only FROM '.$db->prefix.'forums WHERE id='.$id) or error('Unable to fetch forum info', __FILE__, __LINE__, $db->error());
if (!$db->num_rows($result))
	message($lang_common['Bad request'], true);

list($forum_name, $moderators, $num_topics, $closed, $admmod_only) = $db->fetch_row($result);

if ($admmod_only == '1' && $cur_user['status'] < PUN_MOD)
	message($lang_common['Bad request']);

$mods_array = array();
if ($moderators != '')
{
	$mods_array = unserialize($moderators);

	while (list($mod_username, $mod_id) = @each($mods_array))
		$temp_array[] = '<a href="profile.php?id='.$mod_id.'">'.pun_htmlspecialchars($mod_username).'</a>';

	$mods_string = implode(', ', $temp_array);
}

if ($cur_user['status'] == PUN_ADMIN || ($cur_user['status'] == PUN_MOD && array_key_exists($cur_user['username'], $mods_array)))
	$is_admmod = true;
else
	$is_admmod = false;

if ($closed == '0')
{
	if ($pun_config['p_guests_post_topic'] == '0' && $cookie['is_guest'] || $pun_config['p_users_post_topic'] == '0' && $cur_user['status'] < PUN_MOD)
		$post_link = '&nbsp;';
	else
		$post_link = '<a href="post.php?fid='.$id.'">'.$lang_forum['Post topic'].'</a>';
}
else
{
	$post_link = $lang_forum['Forum closed'];

	if ($is_admmod)
		$post_link .= ' / <a href="post.php?fid='.$id.'">'.$lang_forum['Post topic'].'</a>';
}


$page_title = pun_htmlspecialchars($pun_config['o_board_title']).' / '.pun_htmlspecialchars($forum_name);
require $pun_root.'header.php';

?>
<table class="punspacer" cellspacing="1" cellpadding="4">
	<tr>
		<td style="width: 53%"><b><a href="index.php"><?php echo pun_htmlspecialchars($pun_config['o_board_title']) ?></a> / <?php echo pun_htmlspecialchars($forum_name) ?></b></td>
		<td class="punright" style="width: 28%"><?php echo (!empty($mods_array)) ? $lang_forum['Moderated by'].' '.$mods_string : '&nbsp;' ?></td>
		<td class="punright" style="width: 19%; white-space: nowrap"><b><?php echo $post_link ?></b></td>
	</tr>
</table>

<table class="punmain" cellspacing="1" cellpadding="4">
	<tr class="punhead">
		<td class="punhead" style="width: 24px">&nbsp;</td>
		<td class="punhead" style="white-space: nowrap"><?php echo $lang_common['Topic'] ?></td>
		<td class="punhead" style="width: 14%; white-space: nowrap"><?php echo $lang_common['Author'] ?></td>
		<td class="punheadcent" style="width: 7%; white-space: nowrap"><?php echo $lang_common['Replies'] ?></td>
		<td class="punheadcent" style="width: 7%; white-space: nowrap"><?php echo $lang_forum['Views'] ?></td>
		<td class="punhead" style="width: 25%; white-space: nowrap"><?php echo $lang_common['Last post'] ?></td>
	</tr>
<?php


// Determine the topic offset (based on $_GET['p'])
$num_pages = ceil($num_topics / $disp_topics);

$p = (!isset($_GET['p']) || $_GET['p'] <= 1 || $_GET['p'] > $num_pages) ? 1 : $_GET['p'];
$start_from = $disp_topics * ($p - 1);


// Fetch topics (with or without "the dot")
if ($cookie['is_guest'] || $pun_config['o_show_dot'] == '0')
{
	// Without "the dot"
	$result = $db->query('SELECT id, poster, subject, posted, last_post, last_post_id, last_poster, num_views, num_replies, closed, sticky, moved_to FROM '.$db->prefix.'topics WHERE forum_id='.$id.' ORDER BY sticky DESC, last_post DESC LIMIT '.$start_from.', '.$disp_topics) or error('Unable to fetch topic list for forum', __FILE__, __LINE__, $db->error());
}
else
{
	// Fetch topic ID's
	$result = $db->query('SELECT id FROM '.$db->prefix.'topics WHERE forum_id='.$id.' ORDER BY sticky DESC, last_post DESC LIMIT '.$start_from.', '.$disp_topics) or error('Unable to fetch topic list for forum', __FILE__, __LINE__, $db->error());

	$topic_ids = '0';
	while ($row = $db->fetch_row($result))
		$topic_ids .= ','.$row[0];

	// Fetch topics
	$result = $db->query('SELECT DISTINCT p.poster_id AS has_posted, t.id, t.subject, t.poster, t.posted, t.last_post, t.last_post_id, t.last_poster, t.num_views, t.num_replies, t.closed, t.sticky, t.moved_to FROM '.$db->prefix.'topics AS t LEFT JOIN '.$db->prefix.'posts AS p ON t.id=p.topic_id AND p.poster_id='.$cur_user['id'].' WHERE t.id IN('.$topic_ids.') ORDER BY t.sticky DESC, t.last_post DESC') or error('Unable to fetch topic list for forum', __FILE__, __LINE__, $db->error());
}


// If there are topics in this forum.
if ($db->num_rows($result))
{
	while ($cur_topic = $db->fetch_assoc($result))
	{
		if ($cur_topic['moved_to'] == null)
			$last_post = '<a href="viewtopic.php?pid='.$cur_topic['last_post_id'].'#'.$cur_topic['last_post_id'].'">'.format_time($cur_topic['last_post']).'</a> '.$lang_common['by'].' '.pun_htmlspecialchars($cur_topic['last_poster']);
		else
			$last_post = '&nbsp;';

		if ($pun_config['o_censoring'] == '1')
			$cur_topic['subject'] = censor_words($cur_topic['subject']);

		if ($cur_topic['moved_to'] != 0)
			$subject = $lang_forum['Moved'].': <a href="viewtopic.php?id='.$cur_topic['moved_to'].'">'.pun_htmlspecialchars($cur_topic['subject']).'</a>';
		else if ($cur_topic['closed'] == '0' && $closed == '0')
			$subject = '<a href="viewtopic.php?id='.$cur_topic['id'].'">'.pun_htmlspecialchars($cur_topic['subject']).'</a>';
		else
			$subject = '<a class="punclosed" href="viewtopic.php?id='.$cur_topic['id'].'">'.pun_htmlspecialchars($cur_topic['subject']).'</a>';

		if (!$cookie['is_guest'] && $cur_topic['last_post'] > $cur_user['last_visit'] && $cur_topic['moved_to'] == null)
		{
			if ($cur_user['show_img'] == '1')
				$icon = '<img src="img/'.$cur_user['style'].'_new.png" width="16" height="16" alt="">';
			else
				$icon = '<span class="puntext"><b>&#8226;</b></span>';

			$subject = '<b>'.$subject.'</b>';
			$subject_new_posts = '[&nbsp;<a href="viewtopic.php?id='.$cur_topic['id'].'&amp;action=new" title="'.$lang_common['New posts info'].'">'.$lang_common['New posts'].'</a>&nbsp;]';
		}
		else
		{
			$icon = '&nbsp;';
			$subject_new_posts = null;
		}


		// Should we display the dot or not? :)
		if (!$cookie['is_guest'] && $pun_config['o_show_dot'] == '1')
		{
			if ($cur_topic['has_posted'] == $cur_user['id'])
				$subject = '<b>&middot;</b>&nbsp;'.$subject;
			else
				$subject = '&nbsp;&nbsp;'.$subject;
		}

		if ($cur_topic['sticky'] == '1')
			$subject = $lang_forum['Sticky'].': '.$subject;


		$num_pages_topic = ceil(($cur_topic['num_replies'] + 1) / $disp_posts);

		if ($num_pages_topic > 1)
		{
			$stop = ($num_pages_topic < 3) ? ($num_pages_topic + 1) : 4;

			$subject_multipage = '[';
			for ($current = 1; $current < $stop; ++$current)
				$subject_multipage .= '&nbsp;<a href="viewtopic.php?id='.$cur_topic['id'].'&amp;p='.$current.'">'.$current.'</a>';

			if ($num_pages_topic > 3)
				$subject_multipage .= '&nbsp;...&nbsp;<a href="viewtopic.php?id='.$cur_topic['id'].'&amp;p='.$num_pages_topic.'">'.$num_pages_topic.'</a>&nbsp;]';
			else
				$subject_multipage .= '&nbsp;]';
		}
		else
			$subject_multipage = null;

		// Should we show the "New posts" and/or the multipage links?
		if (!empty($subject_new_posts) || !empty($subject_multipage))
		{
			$subject .= '&nbsp; '.(!empty($subject_new_posts) ? $subject_new_posts : '');
			$subject .= !empty($subject_multipage) ? ' '.$subject_multipage : '';
		}

?>
	<tr class="puntopic">
		<td class="puncon1cent"><?php echo $icon ?></td>
		<td class="puncon2"><?php echo $subject ?></td>
		<td class="puncon1"><?php echo pun_htmlspecialchars($cur_topic['poster']) ?></td>
		<td class="puncon2cent"><?php echo ($cur_topic['moved_to'] == null) ? $cur_topic['num_replies'] : '&nbsp;' ?></td>
		<td class="puncon1cent"><?php echo ($cur_topic['moved_to'] == null) ? $cur_topic['num_views'] : '&nbsp;' ?></td>
		<td class="puncon2" style="white-space: nowrap"><?php echo $last_post ?></td>
	</tr>
<?php

	}
}
else
	echo "\t".'<tr><td class="puncon1" colspan="6">'.$lang_forum['Empty forum'].'</td></tr>'."\n";

?>
</table>

<table class="punspacer" cellspacing="1" cellpadding="4">
	<tr>
		<td><?php echo $lang_common['Pages'].': '.paginate($num_pages, $p, 'viewforum.php?id='.$id) ?></td>
		<td class="punright"><b><?php echo $post_link ?></b></td>
	</tr>
</table>
<?php

$forum_id = $id;
$footer_style = 'forum';
require $pun_root.'footer.php';
